﻿using ContextAop.Proxy;
using ContextAop.Transaction;
using System;
using System.Runtime.Remoting.Proxies;

namespace ContextAop.Attribute
{
    public class AopProxyAttribute : ProxyAttribute
    {
        public override MarshalByRefObject CreateInstance(Type serverType)
        {
            var instance = base.CreateInstance(serverType);
            //AopRealProxy realProxy = new AopRealProxy(serverType, instance);
            //事物入侵
            TransactionAopRealProxy realProxy = new TransactionAopRealProxy(serverType, instance);
            realProxy.InterceptionTransaction(new TransactionRealize());
            return realProxy.GetTransparentProxy() as MarshalByRefObject;
        }
    }
}
