﻿using MySql.Data.MySqlClient;
using System.Configuration;
using System.Data;

namespace ContextAop.Helper
{
    public class MySqlDBManager
    {
        private static string MySQLConnString = ConfigurationManager.ConnectionStrings["DefaultDB"].ConnectionString;

        /// <summary>
        /// 获取数据列表
        /// </summary>
        /// <param name="sql"></param>
        /// <param name="connString"></param>
        /// <returns></returns>
        public static DataSet GetMySqlData(string sql)
        {
            DataSet ds = new DataSet();
            try
            {
                using (MySqlConnection conn = new MySqlConnection(MySQLConnString))
                {
                    conn.Open();
                    new MySqlDataAdapter(sql, conn).Fill(ds);
                }
            }
            catch { throw; }

            return ds;
        }

        /// <summary>
        /// 修改数据
        /// </summary>
        /// <param name="sql"></param>
        /// <param name="connString"></param>
        /// <returns></returns>
        public static bool ExecuteNonQuery(string sql)
        {
            bool result = false;
            using (MySqlConnection conn = new MySqlConnection(MySQLConnString))
            {
                conn.Open();
                MySqlCommand cmd = new MySqlCommand(sql, conn);
                result = cmd.ExecuteNonQuery() > 0 ? true : false;
                //try { result = cmd.ExecuteNonQuery() > 0 ? true : false; }
                //catch { return false; }
            }
            return result;
        }

        /// <summary>
        /// 获取object
        /// </summary>
        /// <param name="sql"></param>
        /// <returns></returns>
        public static object ExecuteScalar(string sql)
        {
            using (MySqlConnection conn = new MySqlConnection(MySQLConnString))
            {
                conn.Open();
                MySqlCommand cmd = new MySqlCommand(sql, conn);
                try { return cmd.ExecuteScalar(); }
                catch { throw; }
            }
        }
    }
}
