﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Transactions;

namespace ContextAop.Transaction
{
    public class TransactionRealize:ITransaction
    {
        private TransactionScope transaction = null;

        /// <summary>
        /// 开始事务
        /// </summary>
        public void BeginTransaction()
        {
            transaction = new TransactionScope();
        }

        /// <summary>
        /// 提交事务
        /// </summary>
        public void CommitTransaction()
        {
            transaction.Complete();
            transaction.Dispose();
        }

        /// <summary>
        /// 回滚事务
        /// 执行Dispose不提交事务
        /// </summary>
        public void RollbackTransaction()
        {
            transaction.Dispose();
        }
    }
}
