﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Reflection;
using System.Runtime.Remoting.Messaging;
using System.Runtime.Remoting.Proxies;
using System.Text;
using System.Threading.Tasks;

namespace RealProxyAop
{
    public class AopRealProxy<T> : RealProxy
    {
        private T _target;
        public AopRealProxy(T target) : base(typeof(T))
        {
            this._target = target;
        }

        public override IMessage Invoke(IMessage msg)
        {
            var methodCall = msg as IMethodCallMessage;
            var methodInfo = methodCall.MethodBase as MethodInfo;
            Before(msg);
            try
            {
                var result = methodInfo.Invoke(_target, methodCall.InArgs);
                After(msg);
                return new ReturnMessage(result, null, 0, methodCall.LogicalCallContext, methodCall);
            }
            catch(Exception ex)
            {
                Excepting(msg);
                return new ReturnMessage(ex, methodCall);
            }
        }

        public void Before(IMessage msg)
        {
            Console.WriteLine("方法执行前");
        }

        public void After(IMessage msg)
        {
            Console.WriteLine("方法执行后");
        }

        public void Excepting(IMessage msg)
        {
            Console.WriteLine("异常执行");
        }
    }
}
